"use strict";
var __extends = (this && this.__extends)/* istanbul ignore next */ || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var base_1 = require("./../../base");
var TsBaseDefinitionBinder_1 = require("./TsBaseDefinitionBinder");
var TsNamedBinderByNode_1 = require("./TsNamedBinderByNode");
var TsTypeParameteredBinderByNode_1 = require("./TsTypeParameteredBinderByNode");
var TsParameteredBinderByNode_1 = require("./TsParameteredBinderByNode");
var TsReturnTypedBinderByNode_1 = require("./TsReturnTypedBinderByNode");
var TsNodedBinder_1 = require("./TsNodedBinder");
var TsOverloadSignaturedBinder_1 = require("./TsOverloadSignaturedBinder");
var TsDocumentationedBinder_1 = require("./TsDocumentationedBinder");
var TsBaseFunctionBinderByNodes = (function (_super) {
    __extends(TsBaseFunctionBinderByNodes, _super);
    function TsBaseFunctionBinderByNodes(factory, nodes, paramDefinition, paramBinder) {
        var _this;
        // use the first node for ambient declarations (where there is no implementation signature)
        var node;
        if (nodes.length > 1 && nodes[0].isAmbient())
            node = nodes[0];
        else
            node = nodes[nodes.length - 1];
        _this = _super.call(this, new TsBaseDefinitionBinder_1.TsBaseDefinitionBinder(), new TsNamedBinderByNode_1.TsNamedBinderByNode(node), new TsTypeParameteredBinderByNode_1.TsTypeParameteredBinderByNode(factory, node), new TsParameteredBinderByNode_1.TsParameteredBinderByNode(factory, node, paramDefinition, paramBinder), new TsReturnTypedBinderByNode_1.TsReturnTypedBinderByNode(factory, node), new TsNodedBinder_1.TsNodedBinder(factory, node), new TsOverloadSignaturedBinder_1.TsOverloadSignaturedBinder(factory, nodes), new TsDocumentationedBinder_1.TsDocumentationedBinder(node)) || this;
        _this.factory = factory;
        _this.node = node;
        return _this;
    }
    TsBaseFunctionBinderByNodes.prototype.getIsGenerator = function () {
        return this.node.isGeneratorFunction();
    };
    TsBaseFunctionBinderByNodes.prototype.getUserDefinedTypeGuard = function () {
        var userDefinedTypeGuard = null;
        for (var _i = 0, _a = this.node.getChildren(); _i < _a.length; _i++) {
            var node = _a[_i];
            if (node.isUserDefinedTypeGuard()) {
                userDefinedTypeGuard = this.factory.getUserDefinedTypeGuardFromNode(node);
                break;
            }
        }
        return userDefinedTypeGuard;
    };
    return TsBaseFunctionBinderByNodes;
}(base_1.BaseFunctionBinder));
exports.TsBaseFunctionBinderByNodes = TsBaseFunctionBinderByNodes;

//# sourceMappingURL=TsBaseFunctionBinderByNodes.js.map
