"use strict";
var utils_1 = require("./../../utils");
var TsCache = (function () {
    function TsCache() {
        this.nodeCache = new utils_1.KeyValueCache();
        this.typeNodeCache = new utils_1.KeyValueCache();
        this.symbolCache = new utils_1.KeyValueCache();
    }
    TsCache.prototype.getSymbol = function (symbol, createFunc) {
        return this.symbolCache.getOrCreate(symbol, function () { return createFunc(); });
    };
    TsCache.prototype.getNode = function (node, createFunc) {
        return this.nodeCache.getOrCreate(node, function () { return createFunc(); });
    };
    TsCache.prototype.getTypeNode = function (node, createFunc) {
        return this.typeNodeCache.getOrCreate(node, function () { return createFunc(); });
    };
    return TsCache;
}());
exports.TsCache = TsCache;

//# sourceMappingURL=TsCache.js.map
