"use strict";
var __extends = (this && this.__extends)/* istanbul ignore next */ || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var utils_1 = require("./../../../utils");
var BaseExpressionDefinition_1 = require("./BaseExpressionDefinition");
var BaseTypeDefinition = (function (_super) {
    __extends(BaseTypeDefinition, _super);
    function BaseTypeDefinition() {
        var _this = _super.apply(this, arguments) || this;
        _this.arrayElementType = null;
        _this.intersectionTypes = [];
        _this.unionTypes = [];
        _this.definitions = [];
        _this.properties = [];
        _this.typeArguments = [];
        return _this;
    }
    BaseTypeDefinition.prototype.getAllDefinitions = function () {
        var arraysOfDefinitions = this.unionTypes.map(function (t) { return t.getAllDefinitions(); }).concat(this.intersectionTypes.map(function (t) { return t.getAllDefinitions(); }), this.typeArguments.map(function (t) { return t.getAllDefinitions(); }), this.properties.map(function (p) { return p.type.getAllDefinitions(); }));
        var definitions = this.definitions.concat(arraysOfDefinitions.reduce(function (a, b) { return a.concat(b); }, []));
        if (this.arrayElementType != null) {
            definitions.push.apply(definitions, this.arrayElementType.definitions);
        }
        return utils_1.ArrayUtils.getUniqueItems(definitions);
    };
    BaseTypeDefinition.prototype.getIntersectionType = function (searchFunction) {
        return utils_1.DefinitionUtils.getDefinitionFromListByFunc(this.intersectionTypes, searchFunction);
    };
    BaseTypeDefinition.prototype.getUnionType = function (searchFunction) {
        return utils_1.DefinitionUtils.getDefinitionFromListByFunc(this.unionTypes, searchFunction);
    };
    BaseTypeDefinition.prototype.getDefinition = function (searchFunction) {
        return utils_1.DefinitionUtils.getDefinitionFromListByFunc(this.definitions, searchFunction);
    };
    BaseTypeDefinition.prototype.getProperty = function (searchFunctionOrName) {
        return utils_1.DefinitionUtils.getDefinitionFromListByNameOrFunc(this.properties, searchFunctionOrName);
    };
    BaseTypeDefinition.prototype.getTypeArgument = function (searchFunction) {
        return utils_1.DefinitionUtils.getDefinitionFromListByFunc(this.typeArguments, searchFunction);
    };
    BaseTypeDefinition.prototype.isArrayType = function () {
        return this.arrayElementType != null || /\[\]$/.test(this.text) || /^Array\<.*\>$/.test(this.text);
    };
    return BaseTypeDefinition;
}(BaseExpressionDefinition_1.BaseExpressionDefinition));
exports.BaseTypeDefinition = BaseTypeDefinition;

//# sourceMappingURL=BaseTypeDefinition.js.map
