"use strict";
var main_1 = require("./../../../main");
var testHelpers_1 = require("./../../testHelpers");
describe("prefix type tests", function () {
    var code = "\nnamespace MyNamespace {\n    export class MyClass {\n    }\n    export type MyTypeAlias = { prop: string; };\n}\n\nlet t: MyNamespace.MyClass;\nlet u: MyNamespace.MyTypeAlias;\n";
    var def = main_1.getInfoFromString(code);
    testHelpers_1.runFileDefinitionTests(def, {
        namespaces: [{
                name: "MyNamespace",
                classes: [{
                        name: "MyClass",
                        isExported: true
                    }],
                typeAliases: [{
                        name: "MyTypeAlias",
                        type: { text: "{ prop: string; }" },
                        isExported: true
                    }],
                exports: [{
                        name: "MyClass"
                    }, {
                        name: "MyTypeAlias"
                    }]
            }],
        variables: [{
                name: "t",
                type: {
                    text: "MyNamespace.MyClass",
                    node: {
                        text: "MyNamespace.MyClass"
                    }
                }
            }, {
                name: "u",
                type: {
                    text: "MyNamespace.MyTypeAlias",
                    node: {
                        text: "MyNamespace.MyTypeAlias"
                    }
                }
            }]
    });
});

//# sourceMappingURL=prefixTypeTests.js.map
