"use strict";
var main_1 = require("./../../../main");
var testHelpers_1 = require("./../../testHelpers");
var definitions_1 = require("./../../../definitions");
describe("variable tests", function () {
    var code = "\n/**\n * Some description\n */\nvar myImplicitAny;\nvar myExplicitTypeVar: number;\nvar myImplicitTypeVar = \"my string\";\nvar myMultilineImplicitAny1,\n    myMultilineImplicitAny2,\n    myMultilineImplicitAny3;\nvar myMultilineExplicitTypeVar1: boolean,\n    myMultilineExplicitTypeVar2: number;\nvar myMultilineImplicitTypeVar1 = \"my string\",\n    myMultilineImplicitTypeVar2 = 42;\n\nlet myLet: string;\nlet myMultilineLet1: number,\n    myMultilineLet2;\n\nconst myConst: number;\nconst myMultilineConst1: number,\n      myMultilineConst2: string;\n";
    var def = main_1.getInfoFromString(code);
    testHelpers_1.runFileDefinitionTests(def, {
        variables: [{
                name: "myImplicitAny",
                declarationType: definitions_1.VariableDeclarationType.Var,
                type: { text: "any" },
                documentationComment: "/**\n * Some description\n */"
            }, {
                name: "myExplicitTypeVar",
                declarationType: definitions_1.VariableDeclarationType.Var,
                type: { text: "number" }
            }, {
                name: "myImplicitTypeVar",
                declarationType: definitions_1.VariableDeclarationType.Var,
                type: { text: "string" },
                defaultExpression: { text: "\"my string\"" }
            }, {
                name: "myMultilineImplicitAny1",
                declarationType: definitions_1.VariableDeclarationType.Var,
                type: { text: "any" }
            }, {
                name: "myMultilineImplicitAny2",
                declarationType: definitions_1.VariableDeclarationType.Var,
                type: { text: "any" }
            }, {
                name: "myMultilineImplicitAny3",
                declarationType: definitions_1.VariableDeclarationType.Var,
                type: { text: "any" }
            }, {
                name: "myMultilineExplicitTypeVar1",
                declarationType: definitions_1.VariableDeclarationType.Var,
                type: { text: "boolean" }
            }, {
                name: "myMultilineExplicitTypeVar2",
                declarationType: definitions_1.VariableDeclarationType.Var,
                type: { text: "number" }
            }, {
                name: "myMultilineImplicitTypeVar1",
                declarationType: definitions_1.VariableDeclarationType.Var,
                type: { text: "string" },
                defaultExpression: { text: "\"my string\"" }
            }, {
                name: "myMultilineImplicitTypeVar2",
                declarationType: definitions_1.VariableDeclarationType.Var,
                type: { text: "number" },
                defaultExpression: { text: "42" }
            }, {
                name: "myLet",
                declarationType: definitions_1.VariableDeclarationType.Let,
                type: { text: "string" }
            }, {
                name: "myMultilineLet1",
                declarationType: definitions_1.VariableDeclarationType.Let,
                type: { text: "number" }
            }, {
                name: "myMultilineLet2",
                declarationType: definitions_1.VariableDeclarationType.Let,
                type: { text: "any" }
            }, {
                name: "myConst",
                declarationType: definitions_1.VariableDeclarationType.Const,
                type: { text: "number" }
            }, {
                name: "myMultilineConst1",
                declarationType: definitions_1.VariableDeclarationType.Const,
                type: { text: "number" }
            }, {
                name: "myMultilineConst2",
                declarationType: definitions_1.VariableDeclarationType.Const,
                type: { text: "string" }
            }]
    });
});

//# sourceMappingURL=variableTests.js.map
