"use strict";
var Logger = (function () {
    /* istanbul ignore next */ function Logger() {
    }
    Logger.getIsEnabled = function () {
        return this.isEnabled;
    };
    Logger.enable = function () {
        this.setEnabled(true);
    };
    Logger.disable = function () {
        this.setEnabled(false);
    };
    Logger.setEnabled = function (isEnabled) {
        this.isEnabled = isEnabled;
    };
    Logger.setLogFunction = function (logFunction) {
        this.logFunction = logFunction;
    };
    Logger.setWarnFunction = function (warnFunction) {
        this.warnFunction = warnFunction;
    };
    Logger.setErrorFunction = function (errorFunction) {
        this.errorFunction = errorFunction;
    };
    Logger.log = function (message) {
        this.logWithFunction(message, this.logFunction);
    };
    Logger.warn = function (message) {
        this.logWithFunction(message, this.warnFunction);
    };
    Logger.error = function (message) {
        this.logWithFunction(message, this.errorFunction);
    };
    Logger.logWithFunction = function (message, func) {
        // todo: if an error is passed in here, log the trace property
        if (this.isEnabled)
            func("[ts-type-info]: " + message);
    };
    return Logger;
}());
Logger.isEnabled = false;
Logger.logFunction = console.log;
Logger.warnFunction = console.warn;
Logger.errorFunction = console.error;
exports.Logger = Logger;

//# sourceMappingURL=Logger.js.map
