"use strict";
var __extends = (this && this.__extends)/* istanbul ignore next */ || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var WriteFlags_1 = require("./../WriteFlags");
var BaseDefinitionWriter_1 = require("./BaseDefinitionWriter");
var DecoratorWriter = (function (_super) {
    __extends(DecoratorWriter, _super);
    function DecoratorWriter() {
        return _super.apply(this, arguments) || this;
    }
    DecoratorWriter.prototype.write = function (def, flags) {
        _super.prototype.write.call(this, def, flags);
        this.writer.newLine();
    };
    DecoratorWriter.prototype.writeInline = function (def, flags) {
        _super.prototype.writeInline.call(this, def, flags);
        this.writer.write(" ");
    };
    DecoratorWriter.prototype.writeDefault = function (def, flags) {
        if (flags & WriteFlags_1.WriteFlags.HideFunctionImplementations)
            return;
        this.writer.write("@");
        this.writer.write(def.name);
        if (def.isDecoratorFactory)
            this.writeArgs(def);
    };
    DecoratorWriter.prototype.writeArgs = function (def) {
        var _this = this;
        this.writer.write("(");
        def.arguments.forEach(function (arg, i) {
            _this.writer.conditionalWrite(i !== 0, ", ");
            _this.writer.write(arg.text);
        });
        this.writer.write(")");
    };
    return DecoratorWriter;
}(BaseDefinitionWriter_1.BaseDefinitionWriter));
exports.DecoratorWriter = DecoratorWriter;

//# sourceMappingURL=DecoratorWriter.js.map
