"use strict";
var __extends = (this && this.__extends)/* istanbul ignore next */ || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var BaseWriter_1 = require("./BaseWriter");
var DocumentationedWriter = (function (_super) {
    __extends(DocumentationedWriter, _super);
    function DocumentationedWriter() {
        return _super.apply(this, arguments) || this;
    }
    DocumentationedWriter.prototype.write = function (def) {
        if (def.documentationComment == null || def.documentationComment.length === 0)
            return;
        if (!/^\s*\/\*\*[\s\S]*\*\//.test(def.documentationComment))
            this.writeWithComment(def.documentationComment);
        else
            this.writer.writeLine(def.documentationComment);
    };
    DocumentationedWriter.prototype.writeWithComment = function (text) {
        var _this = this;
        this.writer.writeLine("/**");
        text.split(/\r?\n/).forEach(function (line) { return _this.writer.write(" * ").write(line).newLine(); });
        this.writer.writeLine(" */");
    };
    return DocumentationedWriter;
}(BaseWriter_1.BaseWriter));
exports.DocumentationedWriter = DocumentationedWriter;

//# sourceMappingURL=DocumentationedWriter.js.map
