"use strict";
var __extends = (this && this.__extends)/* istanbul ignore next */ || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var BaseDefinitionWriter_1 = require("./BaseDefinitionWriter");
var EnumMemberWriter_1 = require("./EnumMemberWriter");
var DocumentationedWriter_1 = require("./DocumentationedWriter");
var EnumWriter = (function (_super) {
    __extends(EnumWriter, _super);
    function EnumWriter() {
        var _this = _super.apply(this, arguments) || this;
        _this.documentationedWriter = new DocumentationedWriter_1.DocumentationedWriter(_this.writer);
        _this.enumMemberWriter = new EnumMemberWriter_1.EnumMemberWriter(_this.writer);
        return _this;
    }
    EnumWriter.prototype.writeDefault = function (def, flags) {
        var _this = this;
        this.documentationedWriter.write(def);
        this.writeExportKeyword(def, flags);
        this.writeDeclareKeyword(def);
        this.writeConstKeyword(def);
        this.writer.write("enum " + def.name).block(function () {
            _this.writeMembers(def.members, flags);
        });
    };
    EnumWriter.prototype.writeMembers = function (members, flags) {
        var _this = this;
        members.forEach(function (member, i) {
            _this.enumMemberWriter.write(member, flags);
            if (i !== members.length - 1) {
                _this.writer.write(",").newLine();
            }
        });
    };
    return EnumWriter;
}(BaseDefinitionWriter_1.BaseDefinitionWriter));
exports.EnumWriter = EnumWriter;

//# sourceMappingURL=EnumWriter.js.map
