"use strict";
var __extends = (this && this.__extends)/* istanbul ignore next */ || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var TypeParametersWriter_1 = require("./TypeParametersWriter");
var ExpressionWriter_1 = require("./ExpressionWriter");
var DocumentationedWriter_1 = require("./DocumentationedWriter");
var BaseDefinitionWriter_1 = require("./BaseDefinitionWriter");
var TypeAliasWriter = (function (_super) {
    __extends(TypeAliasWriter, _super);
    function TypeAliasWriter() {
        var _this = _super.apply(this, arguments) || this;
        _this.documentationedWriter = new DocumentationedWriter_1.DocumentationedWriter(_this.writer);
        _this.expressionWriter = new ExpressionWriter_1.ExpressionWriter(_this.writer);
        _this.typeParametersWriter = new TypeParametersWriter_1.TypeParametersWriter(_this.writer);
        return _this;
    }
    TypeAliasWriter.prototype.writeDefault = function (def, flags) {
        this.documentationedWriter.write(def);
        this.writeDeclareKeyword(def);
        this.writeExportKeyword(def, flags);
        this.writer.write("type ").write(def.name);
        this.typeParametersWriter.write(def.typeParameters, flags);
        this.expressionWriter.writeWithEqualsSign(def.type);
        this.writer.write(";").newLine();
    };
    return TypeAliasWriter;
}(BaseDefinitionWriter_1.BaseDefinitionWriter));
exports.TypeAliasWriter = TypeAliasWriter;

//# sourceMappingURL=TypeAliasWriter.js.map
