"use strict";
var __extends = (this && this.__extends)/* istanbul ignore next */ || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var definitions_1 = require("./../definitions");
var BaseDefinitionWriter_1 = require("./BaseDefinitionWriter");
var DocumentationedWriter_1 = require("./DocumentationedWriter");
var TypeWithDefaultExpressionWriter_1 = require("./TypeWithDefaultExpressionWriter");
var VariableWriter = (function (_super) {
    __extends(VariableWriter, _super);
    function VariableWriter() {
        var _this = _super.apply(this, arguments) || this;
        _this.documentationedWriter = new DocumentationedWriter_1.DocumentationedWriter(_this.writer);
        _this.typeWithDefaultExpressionWriter = new TypeWithDefaultExpressionWriter_1.TypeWithDefaultExpressionWriter(_this.writer);
        return _this;
    }
    VariableWriter.prototype.writeDefault = function (def, flags) {
        this.documentationedWriter.write(def);
        this.writeDeclareKeyword(def);
        this.writeExportKeyword(def, flags);
        this.writeDeclarationType(def.declarationType);
        this.writer.spaceIfLastNotSpace().write(def.name);
        this.typeWithDefaultExpressionWriter.write(def, flags);
        this.writer.write(";").newLine();
    };
    VariableWriter.prototype.writeDeclarationType = function (declarationType) {
        switch (declarationType) {
            case definitions_1.VariableDeclarationType.Var:
                this.writer.write("var");
                break;
            case definitions_1.VariableDeclarationType.Let:
                this.writer.write("let");
                break;
            case definitions_1.VariableDeclarationType.Const:
                this.writer.write("const");
                break;
            default:
                break;
        }
    };
    return VariableWriter;
}(BaseDefinitionWriter_1.BaseDefinitionWriter));
exports.VariableWriter = VariableWriter;

//# sourceMappingURL=VariableWriter.js.map
